.\" -*- nroff -*-
.\"
.\" Copyright (c) 1996 Doug Rabson
.\"
.\" All rights reserved.
.\"
.\" This program is free software.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE DEVELOPERS ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE DEVELOPERS BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\" $FreeBSD: src/share/man/man9/VOP_OPENCLOSE.9,v 1.1.2.2 1999/09/05 11:27:12 peter Exp $
.\"
.Dd July 24, 1996
.Os
.Dt VOP_OPEN 9
.Sh NAME
.Nm VOP_OPEN ,
.Nm VOP_CLOSE
.Nd open or close a file
.Sh SYNOPSIS
.Fd #include <sys/vnode.h>
.Ft int
.Fn VOP_OPEN "struct vnode *vp" "int mode" "struct ucred *cred" "struct proc *p"
.Ft int
.Fn VOP_CLOSE "struct vnode *vp" "int mode" "struct ucred *cred" "struct proc *p"
.Sh DESCRIPTION
The
.Xr VOP_OPEN 9
entry point is called before a file is accessed by a process and the
.Xr VOP_CLOSE 9
entry point is called after a file is finished with by the process.
.Pp
The arguments are:
.Bl -tag -width mode
.It Ar vp
the vnode of the file
.It Ar mode
the access mode required by the calling process
.It Ar p
the process which is accessing the file
.El
.Pp
The access mode is a set of flags, including
.Dv FREAD ,
.Dv FWRITE ,
.Dv O_NONBLOCK ,
.Dv O_APPEND .
.Sh LOCKS
The vnode
.Fa vp
should be locked on entry and will still be locked on exit for
.Xr VOP_OPEN 9
and unlocked on entry and exit for
.Xr VOP_CLOSE 9 .
.Sh RETURN VALUES
Zero is returned on success, otherwise an error code is returned.
.Sh PSEUDOCODE
.Bd -literal
int
vop_open(struct vnode *vp, int mode, struct ucred *cred, struct proc *p)
{
    /*
     * Most filesystems don't do much here.
     */
    return 0;
}
.Ed
.Sh SEE ALSO
.Xr vnode 9 ,
.Xr VOP_LOOKUP 9
.Sh AUTHORS
This man page was written by Doug Rabson.

